----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    23:37:23 11/20/2011 
-- Design Name: 
-- Module Name:    divider_by_N - divide 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity divider_by_N is
	port (
		rst 		: IN Std_Logic := '0';
		clk_in 	: IN Std_Logic := '0';
		clk_out	: OUT Std_Logic := '1'
	);
end divider_by_N;

architecture divide of divider_by_N is
	Constant N	: Integer := 50000;
	signal counter : Natural;
	begin

		process(clk_in,rst) is
		
		begin  
			if rst = '1' then
				clk_out <= '1';
				counter <= 0;
			elsif rising_edge(clk_in) then
				if counter = N then
					counter <= 1;
					clk_out <= '1';
				elsif counter < N/2 then
					clk_out <= '1';
					counter <= counter+1;
				elsif counter >= N/2 then
					clk_out <= '0';
					counter <= counter+1;
				else
					counter <= counter+1;
				end if;
			end if;
		end process;			
		
end divide;
